(*
Display logic 
*)

DL = Pure +

classes
  term < logic

default
  term

types
  sequent 
  structure
  formula
  struct

arities
  sequent :: term
  structure :: term
  formula :: term

consts

  (*
  Trueprop      :: "sequent => prop"		 	("(_)" 5)
  *)
  I		:: "structure"

  (* Structural Connectives *)
  "Sequent"	:: "[structure, structure] => prop"	
  "*"		:: "structure => structure"		
  ","		:: "[structure, structure] => structure"
  "@"		:: "structure => structure"		

  (* Coercing formula to structure *)
  Structform    :: "formula => structure"		

syntax 

  "@Bracket"	:: "struct => struct"		("'(_')" [0] 1000)
  "@Comma"	:: "[struct, struct] => struct"	("_, _" [20, 21] 20)
  "@Blob"	:: "struct => struct"		("@ _" [30] 30)
  "@Star"	:: "struct => struct"		("* _" [30] 30)
  "@Sequent"    :: "[struct, struct] => prop"("((_)/ |- (_))" [6,6] 5)
  StructId	:: id => struct			("$_")
  StructVar	:: var => struct		("$_")
  ""		:: "formula => struct"		("_")

rules

  (* Display equivalences *)
  sA		"(*$X) |- $Y == *$Y |- $X" (* () *)
  sS		"$X |- *$Y == $Y |- *$X"
  ssA		"$X |- $Y == **$X |- $Y"
  ca2		"$X, $Y |- $Z == $Y |- *$X, $Z"
  cs2		"$X |- $Y, $Z == $X, *$Z |- $Y"
  blob		"$X |- @$Y == @$X |- $Y"

  (* Classical modal structural rules *)
  mla		"$X |- $Z ==> $Y, $X |- $Z"
  pA		"$X, $Y |- $Z ==> $Y, $X |- $Z"
  cA		"$X, $X |- $Z ==> $X |- $Z"
  aA		"$W, ($X, $Y) |- $Z == ($W, $X), $Y |- $Z"
  ila		"$I, $X |- $Z ==> $X |- $Z"
  ils		"$X |- $I, $Z ==> $X |- $Z"

end

ML

fun str_tr (Const("StructId",_)$id) = id
  | str_tr (Const("StructVar",_)$id) = id
  | str_tr (Const("@Blob",_)$U) = (Const("@",dummyT)$str_tr U)
  | str_tr (Const("@Star",_)$U) = (Const("*",dummyT)$str_tr U)
  | str_tr (Const("@Bracket",_)$U) = str_tr U
  | str_tr (Const("@Comma",_)$L$R) = (Const(",",dummyT)$str_tr L$str_tr R)
  | str_tr (fm) = Const("Structform",dummyT)$fm;

fun true_tr[s1,s2] = Const("Sequent",dummyT)$str_tr s1$str_tr s2;

fun str_tr' (Const("Structform",_)$fm) = fm
  | str_tr' (Const("@",_)$U) = (Const("@Blob",dummyT)$str_tr' U)
  | str_tr' (Const("*",_)$U) = (Const("@Star",dummyT)$str_tr' U)
  | str_tr' (Const(",",_)$L$R) = (Const("@Comma",dummyT)$str_tr' L$str_tr' R)
  | str_tr' (id) = Const("StructId",dummyT)$id;

fun true_tr' [s1,s2] =
      Const("@Sequent",dummyT)$str_tr' s1$str_tr' s2;

val parse_translation = [("@Sequent",true_tr)];
val print_translation = [("Sequent",true_tr')];
