
open dKt ;

(* Convert rules to change one side only *)

bind_st_thm ("wbxA", "A |- $X ==> @ wbx A |- $X", wbxa RS md1 blob) ;
bind_thm ("wbxS", md1 blob RS wbxs) ;
bind_st_thm ("wdmS", "$X |- A ==> $X |- *@* wdm A", wdms RS md2 sbs) ;
bind_st_thm ("bbxA", "A |- $X ==> *@* bbx A |- $X", bbxa RS md1 sbs) ;
bind_thm ("bdmA", md2 blob RS bdma) ;
bind_st_thm ("bdmS", "$X |- A ==> $X |- @ bdm A", bdms RS md2 blob) ;

bind_st_thm ("impA", "[| (* A |- $X); B |- $X |] ==> A -> B |- $X", (* () *)
    [md1 ssS, md1 ssS] MRS (md2 dcp RS impa RS cS) RS md2 ssS) ;
bind_thm ("impS", md2 pSe RS md2 ca1 RS imps) ;
bind_thm ("andS", ands RS cA) ;
bind_thm ("orA", ora RS cS) ;

(* Example proofs *)

prove_goal thy "wbx (A -> B) |- wbx A -> wbx B" (* K *)
  (fn _ => [
    rtac imps 1,
    rtac wbxs 1,
    rtac bldista 1,
    d_b_tac "|l" (rtac (wbxa RS md1 blob)) 1,
    d_b_tac "|r" (rtac (wbxa RS md1 blob)) 1,
    disp_tac "|l" 1,
    rtac (md1 pSe) 1,
    rtac impa 1,
    rtac idf 1, rtac idf 1]) ; 

prove_goal thy "wbx A & wdm B |- wdm (A & B)" 
  (fn _ => [
    rtac anda 1,
    d_b_tac "|r" (rtac wdma) 1,
    disp_tac "|r*" 1,
    rtac (md2 cbdista) 1,
    d_b_tac "|r" (rtac (md1 ssA)) 1,
    disp_tac "-@" 1,
    rtac bldista 1,
    disp_tac "|r" 1,
    disp_tac "-l" 1,
    d_b_tac "|l" (rtac wbxA) 1,
    rtac wdmS 1,
    rtac ands 1,
    rtac idf 1, rtac idf 1]) ; 

prove_goal thy "wbx (A -> B) |- wdm A -> wdm B" 
  (fn _ => [
    rtac imps 1,
    d_b_tac "|r" (rtac wdma) 1,
    disp_tac "|r*@" 1,
    d_b_tac "|@" (rtac (md2 cbdista)) 1,
    rtac bldista 1,
    disp_tac "|r" 1,
    disp_tac "-l" 1,
    d_b_tac "|l@" (rtac (md1 ssA)) 1,
    d_b_tac "|l" (rtac wbxA) 1,
    rtac wdmS 1,
    d_b_tac "|l" (rtac impA) 1,
    disp_tac "|r" 1,
    rtac mrs 1,
    rtac mra 2,
    rtac idf 1, rtac idf 1]) ; 

use "dKt.tac" ;
