(*
Display rules for Clasical Modal (Tense) logic 
*)

dKt = DL +

(*
types
  formula

arities
  formula :: term
*)

consts

  (*
  Structform    :: "formula => structure"		("(_)" [50] 40)
  *)
  T, F		:: "formula"

  (* Logical Connectives *)
  "~"		:: "formula => formula"			("~ _" [70] 70)
  "v"		:: "[formula, formula] => formula"	(infixl 65)
  "&"		:: "[formula, formula] => formula"	(infixl 66)
  "->"		:: "[formula, formula] => formula"	(infixl 63)
  wbx		:: "formula => formula"			("wbx _" [70] 70)
  wdm		:: "formula => formula"			("wdm _" [70] 70)
  bbx		:: "formula => formula"			("bbx _" [70] 70)
  bdm		:: "formula => formula"			("bdm _" [70] 70)

rules

  (* $Identity rule for formulae *)
  idf		"A |- A"
  (* Cut rule *)
  cut		"[| $X |- A ; A |- $Y |] ==> $X |- $Y"

  (* Classical modal logical rules *)
  tl		"$I |- $X ==> T |- $X"
  tr		"$I |- T"
  fl		"F |- $X"
  fr		"$X |- $I == $X |- F"
  nota		"( * A |- $X) ==> ~A |- $X" (* () *)
  nots		"$X |- * A ==> $X |- ~ A" 
  anda		"A, B |- $X ==> A & B |- $X"
  ands		"[| $X |- A; $Y |- B |] ==> $X, $Y |- A & B" 
  ora		"[| A |- $X ; B |- $Y |] ==> A v B |- $X, $Y"
  ors		"$X |- A, B ==> $X |- A v B" 
  impa		"[| $X |- A ; B |- $Y |] ==> A -> B |- *$X, $Y"
  imps		"$X, A |- B ==> $X |- A -> B" 
  wbxa		"A |- $X ==> wbx A |- @$X"
  wbxs		"(@$X) |- A ==> $X |- wbx A"  (* () *)
  wdma		"(*@* A) |- $X ==> wdm A |- $X" (* () *)
  wdms		"$X |- A ==> *@* $X |- wdm A" 
  bbxa		"A |- $X ==> bbx A |- *@* $X"
  bbxs		"$X |- *@* A ==> $X |- bbx A" 
  bdma		"A |- @$X ==> bdm A |- $X"
  bdms		"$X |- A ==> @$X |- bdm A" 

end


